#AFK Script
#By Einlanzers

import esm
import time

start_afk_time = 10
check_interval = 5
change_name = False
list_on_join = True
afktime = {}
lastloc = {}
isafk = {}

def load():
  esm.delayed(check_interval, check_afk)

def check_afk():
  curtime = int(time.time())
  for player in esm.server.getOnlinePlayers():
    name = stripname(player.getDisplayName())
    loc = player.getLocation()
    if name in lastloc:
      if lastloc[name].getX() != loc.getX() or lastloc[name].getY() != loc.getY() or lastloc[name].getZ() != loc.getZ():
        afktime[name] = int(time.time())
    lastloc[name] = loc
    if name not in afktime:
      afktime[name] = curtime
    if curtime - afktime[name] < start_afk_time:
      update_afk(player, False)
    else:
      update_afk(player, True)
  esm.delayed(check_interval, check_afk)

def list_afk(player):
  curtime = int(time.time())
  for tplayer in esm.server.getOnlinePlayers():
    tname = stripname(tplayer.getDisplayName())
    if tname not in afktime:
      afktime[tname] = curtime
    if curtime - afktime[tname] < start_afk_time:
      player.sendMessage(tname + ": Active")
    else:
      gonetime = curtime - afktime[tname]
      timef = formattime(gonetime)
      player.sendMessage(tname + ": AFK for " + timef)

def player_join(ev):
  player = ev.getPlayer()
  if list_on_join:
    list_afk(player)
  return True

def player_chat(ev):
  player = ev.getPlayer()
  name = stripname(player.getDisplayName())
  message = ev.getMessage()
  afktime[name] = int(time.time())
  update_afk(player, False)
  if message != "afk":
    return True
  list_afk(player)
  return False

def update_afk(player, blafk):
  curname = player.getDisplayName()
  name = stripname(curname)
  if name not in isafk:
    isafk[name] = False
  if blafk:
    if not isafk[name]:
      if change_name:
        player.setDisplayName(name + "-AFK")
      esm.msg(name + " is now AFK.")
      isafk[name] = True
  else:
    if isafk[name]:
      if change_name:
        player.setDisplayName(name)
      esm.msg(name + " is no longer AFK.")
      isafk[name] = False

def stripname(name):
  if len(name) < 5:
    return name
  shname = name[-4:len(name)]
  if shname == "-AFK":
    return name[0:len(name)-4]
  return name

def formattime(seconds):
  output = ""
  years = seconds / 31536000
  if years != 0 or output != "":
    if output != "":
      output += ", "
    output += str(years) + " years"
    seconds -= 31536000*years
  months = seconds / 2628000
  if months != 0 or output != "":
    if output != "":
      output += ", "
    output += str(months) + " months"
    seconds -= 2628000*months
  days = seconds / 86400
  if days != 0 or output != "":
    if output != "":
      output += ", "
    output += str(days) + " days"
    seconds -= 86400*days
  hours = seconds / 3600
  if hours != 0 or output != "":
    if output != "":
      output += ", "
    output += str(hours) + " hours"
    seconds -= 3600*hours
  minutes = seconds / 60
  if minutes != 0 or output != "":
    if output != "":
      output += ", "
    output += str(minutes) + " minutes"
    seconds -= 60*minutes
  if output != "":
    output += ", "
  output += str(seconds) + " seconds"
  return output 
